"""
    CompiledPermutation(p::AbstractVector{<:Integer}; zero = false)

Compiles a permutation `p` so it can be efficiently applied to multiple vectors

`cp = CompiledPermutation(p); permute!(v, cp)` is equivalent to `permute!(v, p)`
but much faster if applying the permutation multiple times.

Throws an `ArgumentError` if `p` is not a permutation. Setting `zero = true` will 
run slightly faster and zero out the input permutation.

For long vectors it is often still fastest to permute by copying with `v[p]`.

Mutating the fields of a compiled permutation may cause unsafe memory access.
"""
struct CompiledPermutation{T} <: _AbstractPermutation
    data::T
    length::Int
    function CompiledPermutation(permutation::AbstractVector{<:Integer}; zero = false)

        # Internal workings:

        # Legend:
        # swap   2-cycle
        # cycle  a cycle of length 3 or more
        # nic    nonzero input count, nic == count(nonzero, p)
        # _i     index in the output vector out
        # _j     index in the input vector p
        # p_xxx  the result of p[xxx]

        # Input: standard vector permutation
        # Output: compiled permutation listed in reverse-zero-terminated-cycle notation
        # for cycles of length ≥ 3 followed by a consecutive listing of all swaps.
        # For example,
        #
        # [3, 1, 2] -> [1, 3, 2, 0]
        # [3, 2, 1] -> [0, 1, 3]
        # [3, 4, 1, 2] -> [0, 2, 4, 1, 3]
        # [1, 2, 3, 4] -> []
        # [1, 4, 8, 2, 6, 5, 7, 3] -> [1, 2, 7, 0, 5, 6, 3, 4]

        # Exception! for input vectors of length 2, any nonempty vector signifies the swap
        # permutation while the empty vector signifies the identity permutation.
        #
        # [1, 2] -> []
        # [2, 1] -> [x] where x is arbitrary

        p = zero ? permutation : copy(permutation)
        Base.require_one_based_indexing(p)
        nic = length(p)
        if nic <= 2
            nic == 0 && return new{typeof(p)}(similar(p, 0), 0)
            nic == 1 && p[1] == 1 && return new{typeof(p)}(similar(p, 0), 1)
            nic == 2 && p[1] == 1 && p[2] == 2 && return new{typeof(p)}(similar(p, 0), 2)
            nic == 2 && p[1] == 2 && p[2] == 1 && return new{typeof(p)}(similar(p, 1), 2)
            throw(ArgumentError("Input vector p = $p is not a permutation"))
        end
        out = similar(p, nic + nic ÷ 3 + 1)
        cycle_i = 1
        swap_i = length(out)
        input_j = 1

        Base.@propagate_inbounds function read(idx)
            x = p[idx]
            p[idx] = 0
            x
        end

        @inbounds while true
            nic -= 1
            p_input_j = read(input_j) # where does the head point?
            if input_j < p_input_j <= lastindex(p) # head points valid onward
                nic -= 1
                pp_input_j = read(p_input_j) # where does the head point?
                if pp_input_j == input_j # ...back to the start
                    out[swap_i-1] = input_j # register 2-cycle
                    out[swap_i] = p_input_j
                    swap_i -= 2
                elseif input_j < pp_input_j <= lastindex(p) # ...valid onward
                    out[cycle_i] = input_j      # register the first
                    out[cycle_i+1] = p_input_j  # 3 as the start of
                    cycle_i += 2                # a cycle (including
                    # start of loop)
                    while true
                        out[cycle_i] = pp_input_j
                        cycle_i += 1
                        nic -= 1
                        pp_input_j = read(pp_input_j) # where does the head point?
                        input_j < pp_input_j <= lastindex(p) || break # ...valid onward
                    end

                    # did we end where we started or end as invalid?
                    pp_input_j == input_j ||
                        throw(ArgumentError("Input vector p is not a permutation"))

                    out[cycle_i] = 0
                    cycle_i += 1
                else # ...invalid
                    throw(ArgumentError("Input vector p is not a permutation"))
                end
            elseif input_j != p_input_j # ...neither valid onward nor fixed point
                throw(ArgumentError("Input vector p is not a permutation"))
            end # fixed point do nothing
            nic == 0 && break
            input_j = findnext(!iszero, p, input_j + 1)
        end
        if cycle_i == 1
            cycle_i = 2
            out[1] = 0
        end
        swap_len = lastindex(out) - swap_i
        swap_len != 0 && unsafe_copyto!(out, cycle_i, out, swap_i + 1, swap_len)
        resize!(out, cycle_i - 1 + swap_len)
        new{typeof(p)}(out, length(p))
    end
end

function Base.permute!(v, cp::CompiledPermutation)
    p = cp.data
    l = length(cp)
    Base.require_one_based_indexing(v)
    length(v) == l || throw(DimensionMismatch())
    l < 2 && return v
    i = length(p)
    @inbounds begin
        if l == 2
            if i != 0
                v[1], v[2] = v[2], v[1]
            end
            return v
        end

        while true # swaps
            pi = p[i]
            pi > 0 || break
            pim = p[i-1]
            v[pi], v[pim] = v[pim], v[pi]
            i -= 2
        end
        j = 1
        while j < i # cycles
            a, b, c, d = p[j], p[j+1], p[j+2], p[j+3]
            start = v[a]
            v[a] = v[b]
            v[b] = v[c]
            j += 4
            while d > 0
                v[c] = v[d]
                c = d
                d = p[j]
                j += 1
            end
            v[c] = start
        end
    end
    v
end

# TODO constructing an inverse compiled permutation can be as fast as constructing
# a standard compiled permutation and faster than compiling + inverting.
function invperm!(p::CompiledPermutation)
    length(p) <= 2 && return p
    hi = findlast(iszero, p.data)
    reverse!(view(p.data, 1:hi-1))
    p
end
Base.invperm(p::CompiledPermutation) = invperm!(deepcopy(p))
Base.length(p::CompiledPermutation) = p.length

Permutation(p::CompiledPermutation) = Permutation(permute!(collect(1:length(p)), p))
CompiledPermutation(p::Permutation) = CompiledPermutation(p.data)

function cycles(cp::CompiledPermutation{T}) where {T}
    out = Vector{eltype(T)}[]

    p = cp.data
    i = length(p)
    while true # swaps
        pi = p[i]
        pi > 0 || break
        pim = p[i-1]
        push!(out, [pi, pim])
        i -= 2
    end
    j = 1
    while j < i # cycles
        a, b, c, d = p[j], p[j+1], p[j+2], p[j+3]
        new = [a, b, c]
        j += 4
        while d > 0
            push!(new, d)
            d = p[j]
            j += 1
        end
        push!(out, new)
    end
    out
end

module Permutations
using LinearAlgebra, Combinatorics

import Base:
    length,
    show,
    invperm,
    inv,
    reverse,
    ==,
    getindex,
    *,
    ^,
    sign,
    hash,
    getindex,
    Matrix,
    Array,
    AbstractMatrix,
    AbstractArray,
    Array,
    adjoint,
    isone


import Combinatorics: nthperm
import Random: randperm

export Permutation, RandomPermutation
export length, getindex, array, two_row
export invpermute, cycles, cycle_string
export order, matrix, fixed_points
export longest_increasing, longest_decreasing, reverse, sign
export hash, dict, Transposition, CyclePermutation
export apply_transposition, apply_transposition!
export CoxeterDecomposition  # no reason to expose CoxeterGenerator
export CompiledPermutation

# Defines the Permutation class. Permutations are bijections of 1:n.


abstract type _AbstractPermutation end

"""
    Permutation

* `Permutation(list)` creates a new `Permutation`. Here `list` must be a rearrangement of `1:n`.
* `Permutation(n)` creates the identity `Permutation` of `1:n`.
* `Permutation(n,k)` creates the `k`'th `Permutation` of `1:n`.
* `Permutation(P::Matrix{Int})` creates a `Permutation` from a permutation matrix.
* `Permutation(cycles::Vector{Vector{Int}})` creates a `Permutation` from a list of disjoint cycles.
"""
struct Permutation <: _AbstractPermutation
    data::Vector{Int}
    function Permutation(dat::Vector{Int}; validate = true)
        n = length(dat)
        if validate && sort(dat) != collect(1:n)
            error("Improper array: must be a permutation of 1:n")
        end
        new(dat)
    end
end

Permutation(v::AbstractVector) = Permutation(Vector{Int}(v))

# create the k'th permutation of 1:n
function Permutation(n, k)
    return Permutation(nthperm(collect(1:n), k))
end

# create the identity permutation
Permutation(n::Int) = Permutation(collect(1:n))



"""
    CyclePermutation(n::Int)::Permutation

Create the permutation with the single cycle `(1,2,...,n)`.
"""
function CyclePermutation(n::Int)::Permutation
    @assert n > 0 "Require n to be positive"
    return Permutation([collect(1:n)])
end


"""
    Transposition(n,a,b)

Create a permutation of `1:n` swapping `a` for `b`.
"""
function Transposition(n::Int, a::Int, b::Int)::Permutation
    @assert 0 < a ≤ n && 0 < b ≤ n && a ≠ b "Require n,a,b to be positive, with 0 ≤ a ≠ b ≤ n, got n=$n, a=$a, and b=$b"
    list = collect(1:n)
    @inbounds list[a] = b
    @inbounds list[b] = a
    return Permutation(list)
end

"""
    RandomPermutation(n::Int)

Create a random permutation of `1:n`, each with probability `1/factorial(n)`.
"""
RandomPermutation(n::Int) = Permutation(randperm(n))

# Returns the number of elements in the Permutation

"""
    length(p::Permutation)

Return the number of elements in `p`.
"""
function length(p::Permutation)::Int
    return length(p.data)
end

# Check for equality of permutations
==(p::Permutation, q::Permutation) = p.data == q.data

# Apply the Permutation to an element: p[k] or p(k)
getindex(p::Permutation, k::Integer) = p.data[k]
(p::Permutation)(k::Integer) = p.data[k]

# Iteration utility
Base.iterate(p::Permutation, state = 1) =
    state > length(p) ? nothing : (p[state], state + 1)


# Create a two-row representation of this permutation
"""
    two_row(p::Permutation)

Creates a two-row representation of the `Permutation` `p`
in which the first row is `1:n` and the second row are the
values `p(1), p(2), ..., p(n)`.
"""
function two_row(p::Permutation)::Matrix{Int}
    n = length(p)
    return [(1:n)'; p.data']
end

# Composition of two permutations
*(p::Permutation) = p
function *(p::Permutation, q::Permutation)
    n = length(p)
    if n != length(q)
        error("Cannot compose Permutations of different lengths")
    end
    @inbounds dat = [p.data[q.data[k]] for k = 1:n]
    return Permutation(dat)
end

# Inverse of a permutation
"""
    inv(p::Permutation)

Give the inverse of `Permutation` `p`. This may
also be computed with `p'`.
"""
inv(p::_AbstractPermutation) = invperm(p)
adjoint(p::_AbstractPermutation) = invperm(p)

function invperm(p::Permutation)
    n = length(p)
    data = zeros(Int, n)
    for k = 1:n
        @inbounds j = p.data[k]
        @inbounds data[j] = k
    end
    return Permutation(data)
end

"""
    invpermute(v, p::AbstractVector)
    invpermute(v, p::AbstractPermutation)

Equivalent to `v[invperm(p)]` but often more efficient and does not check if `p` is a 
permutation.
"""
Base.@propagate_inbounds function invpermute(v, p::AbstractVector)
    out = similar(v)
    out[p] = v
    out
end
function invpermute(v, p::Permutation)
    axes(v) == axes(p.data) ||
        throw(DimensionMismatch("Data and permutation must have the same axes."))
    @inbounds invpermute(v, p.data)
end
invpermute(v, p::_AbstractPermutation) = invpermute(v, Permutation(p))


# Find the cycles in a permutation
"""
    cycles(p::Permutation)

Return a list of the cycles in `Permutation` `p`.
"""
function cycles(p::Permutation)
    n = length(p)
    result = Array{Int,1}[]
    todo = trues(n)
    k = 1
    while k !== nothing
        todo[k] = false
        cycle = [k]
        j = p[k]
        while j != k
            push!(cycle, j)
            todo[j] = false
            j = p[j]
        end
        push!(result, cycle)
        k = findnext(todo, k)
    end
    return result
end

"""
    cycle_string(p::Permutation)

Create a nice, prinatble string representation
from the cycle structure of the permutation `p`.
"""
function cycle_string(p::_AbstractPermutation)::String
    if length(p) == 0
        return "()"
    end
    str = ""
    cc = cycles(p)
    for c in cc
        str *= "(" * join(c, ',') * ")"
    end
    return str
end

"""
    sign(p::Permutation)

Return `+1` if`p` is an even `Permutation` and `-1` if p is odd.
"""
function sign(p::Permutation)::Int
    n = length(p)
    result = 0
    todo = trues(n)
    while any(todo)
        k = findfirst(todo)
        todo[k] = false
        result += 1 # increment element count
        j = p[k]
        while j != k
            result += 1 # increment element count
            todo[j] = false
            j = p[j]
        end
        result += 1 # increment cycle count
    end
    return isodd(result) ? -1 : 1
end



function Permutation(cc::Vector{Vector{Int}})::Permutation
    # check the list of cycles has exactly one each from 1 to n
    elts = sort(union(cc...))
    n = length(elts)
    plist = collect(1:n)
    @assert elts == plist "Invalid list of cycles"

    for c in cc
        nc = length(c)
        for i = 1:nc
            a = c[i]
            b = c[mod1(i + 1, nc)]
            plist[a] = b
        end
    end
    return Permutation(plist)
end


# When we print a permutation, it appears in disjoint cycle format.
function show(io::IO, p::Permutation)
    print(io, cycle_string(p))
end
function show(io::IO, p::_AbstractPermutation)
    print(io, length(p), "-element ", typeof(p), ": ", cycle_string(p))
end

# Find the smallest positive n such that p^n is the identity
"""
    order(p::Permutation)

Return the smallest positive integer `n`
such that `p^n` is the identity `Permutation`.
"""
function order(p::_AbstractPermutation)
    result = 1
    if length(p) <= 1
        return 1
    end
    clist = cycles(p)
    for c in clist
        result = lcm(result, length(c))
    end
    return result
end

# Extend p^n so negative exponents work too
function ^(p::Permutation, n::Int)
    if n == 0
        return Permutation(length(p))
    end
    if n < 0
        return inv(p)^(-n)
    end
    if n == 1
        return p
    end

    m::Int = round(Int, floor(n / 2)) # int(floor(n/2))  # m = floor(n/2)
    q::Permutation = p^m

    if n % 2 == 0   # if even
        return q * q
    end

    return p * q * q
end


# find the fixed points of a Permutation
"""
    fixed_points(p::Permutation)

Return the list of values `k` for which `p(k)==k`.
"""
fixed_points(p::Permutation) = findall([p[k] == k for k = 1:length(p)])

# Find a longest monotone subsequence of p in a given direction. This
# is not exposed, but it is used by longest_increasing and
# longest_increasing.
function longest_monotone(p::Permutation, order = <)::Vector{Int}
    n = length(p)
    if n == 0
        return Int[]
    end
    scores = ones(Int, n)
    scores[n] = 1

    for k = n-1:-1:1
        for i = k+1:n
            if order(p[k], p[i]) && scores[k] <= scores[i]
                scores[k] = scores[i] + 1
            end
        end
    end

    seq = Int[]
    mx = maximum(scores)
    a = findfirst([s == mx for s in scores])
    push!(seq, a)

    while scores[a] > 1
        val = scores[a] - 1
        idx = findfirst([scores[k] == val && order(p[a], p[k]) for k = a+1:n])
        a += idx
        push!(seq, a)
    end

    return [p[i] for i in seq]

end


"""
    longest_increasing(p::Permutation)

Thinking of `p` as a list of values, return a longest subsequence of values
that are in ascending order.
"""
longest_increasing(p::Permutation) = longest_monotone(p, <)

"""
    longest_decreasing(p::Permutation)

Thinking of `p` as a list of values, return a longest subsequence of values
that are in descending order.
"""
longest_decreasing(p::Permutation) = longest_monotone(p, >)

"""
    reverse(p::Permutation)

Thinking of `p` as a list of values,
return a `Permutation` with those values in reverse
sequence.
"""
function reverse(p::Permutation)::Permutation
    d = reverse(p.data)
    return Permutation(d)
end

# hash function so Permutations can be keys in dictionaries, etc.
hash(p::Permutation, h::UInt64) = hash(p.data, h)

"""
    dict(p::Permutation)

Convert a permutation into a dictionary. If `d` is the
result then `d[k]` equals `p(k)` for all `k` in the domain of the
permutation.
"""
function dict(p::Permutation)::Dict{Int,Int}
    n = length(p)
    d = Dict{Int,Int}()
    for i = 1:n
        d[i] = p(i)
    end
    return d
end

"""
    apply_transposition!(p::Permutation, i, j)

Compose a permutation `p` in-place with the transposition `(i, j)`.
"""
function apply_transposition!(p::Permutation, i::Integer, j::Integer)
    n = length(p)
    @assert 0 < i ≤ n && 0 < j ≤ n && i ≠ j
    p.data[i], p.data[j] = p.data[j], p.data[i]
end

"""
    apply_transposition(p::Permutation, i, j)

Return a new permutation obtained by composing `p` with the transposition `(i, j)`.
"""
function apply_transposition(p::Permutation, i::Integer, j::Integer)
    n = length(p)
    @assert 0 < i ≤ n && 0 < j ≤ n && i ≠ j
    data = copy(p.data)
    data[i], data[j] = data[j], data[i]
    return Permutation(data)
end

#####
# Decomposing into Coxeter generators
#####

struct CoxeterGenerator <: _AbstractPermutation
    n::Int
    i::Int
    function CoxeterGenerator(n::Int, i::Int)
        1 ≤ i ≤ n - 1 || throw(ArgumentError("$i must be between 1 and $n-1"))
        new(n, i)
    end
end

length(sᵢ::CoxeterGenerator) = sᵢ.n
Permutation(P::CoxeterGenerator) = Permutation([1:P.i-1; P.i + 1; P.i; P.i+2:P.n])

function show(io::IO, p::CoxeterGenerator)
    print(io, "length $(p.n) permutation: s_$(p.i)")
end


# _coxeter_reduce reduces a product of simple transpositions using the relationships
# https://en.wikipedia.org/wiki/Symmetric_group#Generators_and_relations
# combined with a sorting for uniqueness
function _coxeter_reduce!(terms::Vector{Int})
    @label start
    for i = 1:length(terms)-1
        # sᵢ^2 = I
        if terms[i] == terms[i+1]
            deleteat!(terms, i:i+1)
            @goto start
        end
        # sort using sᵢsⱼ = sⱼsᵢ
        if terms[i+1] ≠ terms[i] - 1 && terms[i+1] ≠ terms[i] + 1 && terms[i] > terms[i+1]
            terms[i], terms[i+1] = terms[i+1], terms[i]
            @goto start
        end
    end
    # (sᵢsᵢ₊₁)^3 = I
    for i = 1:length(terms)-5
        if terms[i] + 1 ==
           terms[i+1] ==
           terms[i+2] + 1 ==
           terms[i+3] ==
           terms[i+4] + 1 ==
           terms[i+5]
            deleteat!(terms, i:i+5)
            @goto start
        end
    end

    terms
end


"""
    CoxeterDecomposition(p::Permutation)

Express the `Permutation` `p` as a
composition of transpositions of the form `(k,k+1)`.
"""
struct CoxeterDecomposition <: _AbstractPermutation
    n::Int
    terms::Vector{Int}
    function CoxeterDecomposition(n::Int, terms::Vector{Int})
        for t in terms
            1 ≤ t ≤ n - 1 || throw(ArgumentError("$t must be between 1 and $n-1"))
        end
        new(n, _coxeter_reduce!(terms))
    end
end

CoxeterDecomposition(n::Int, terms::AbstractVector) =
    CoxeterDecomposition(n, Vector{Int}(terms))
CoxeterDecomposition(sᵢ::CoxeterGenerator) = CoxeterDecomposition(sᵢ.n, [sᵢ.i])

length(P::CoxeterDecomposition) = P.n

function Permutation(P::CoxeterDecomposition)
    if isempty(P.terms)
        Permutation(1:P.n)
    else
        *(Permutation.(CoxeterGenerator.(P.n, P.terms))...)
    end
end
CoxeterDecomposition(P::Permutation) = CoxeterDecomposition!(Permutation(copy(P.data)))
CoxeterDecomposition!(P::Permutation) =
    CoxeterDecomposition(length(P), _coxeterdecomposition!(P))
function _coxeterdecomposition!(P::Permutation)
    n = length(P)
    data = P.data
    ret = Int[]
    while !issorted(data)
        for k = 1:n-1
            if data[k] > data[k+1]
                data[k], data[k+1] = data[k+1], data[k]
                push!(ret, k)
            end
        end
    end
    reverse!(ret)
end

==(A::CoxeterDecomposition, B::CoxeterDecomposition) = A.terms == B.terms

function *(A::CoxeterGenerator, B::CoxeterGenerator)
    length(A) == length(B) ||
        throw(ArgumentError("Permutations must have same length to multiply"))
    CoxeterDecomposition(length(A), [A.i, B.i])
end
function *(A::CoxeterGenerator, B::CoxeterDecomposition)
    length(A) == length(B) ||
        throw(ArgumentError("Permutations must have same length to multiply"))
    CoxeterDecomposition(length(A), [A.i; B.terms])
end
function *(A::CoxeterDecomposition, B::CoxeterGenerator)
    length(A) == length(B) ||
        throw(ArgumentError("Permutations must have same length to multiply"))
    CoxeterDecomposition(length(A), [A.terms; B.i])
end
function *(A::CoxeterDecomposition, B::CoxeterDecomposition)
    length(A) == length(B) ||
        throw(ArgumentError("Permutations must have same length to multiply"))
    CoxeterDecomposition(length(A), [A.terms; B.terms])
end

invperm(A::CoxeterDecomposition) = CoxeterDecomposition(A.n, reverse(A.terms))

function show(io::IO, p::CoxeterDecomposition)
    print(io, "Permutation of 1:$(length(p)): ")
    if length(p.terms) == 0
        print(io, "()")
    end
    for i in p.terms
        # print(io, "s_$(i)")
        print(io, "($i,$(i+1))")
    end
end


"""
    isone(p::Permutation)::Bool

Return `true` exactly when `p` is an identity `Permutation`.
"""
function isone(p::Permutation)::Bool
    n = length(p)
    return p.data == collect(1:n)
end


# deprecations
@deprecate array(p::Permutation) p.data
@deprecate matrix(p::Permutation, sparse::Bool = false) sparse ? sparse(p) : Matrix(p)

include("matrix.jl")
include("sqrt.jl")
include("perm_gen.jl")
include("CompiledPermutation.jl")
include("extend.jl")

end # end of module Permutations

# Represent as a permutation matrix.
"""
    Matrix(p::Permutation)

Return the permutation matrix for `p`.
"""
function Matrix{T}(p::Permutation) where {T}
    n = length(p)
    A = Matrix{T}(I, n, n)     # A = eye(T,n)   #  int(eye(n))
    return A[:, p.data]
end

Matrix(p::Permutation) = Matrix{Int}(p)
Array(p::Permutation) = Matrix(p)
AbstractMatrix(p::Permutation) = Matrix(p)
AbstractArray(p::Permutation) = Matrix(p)

Array{T}(p::Permutation) where {T} = Matrix{T}(p)
AbstractMatrix{T}(p::Permutation) where {T} = Matrix{T}(p)
AbstractArray{T}(p::Permutation) where {T} = Matrix{T}(p)


function Permutation(M::Matrix)
    n, c = size(M)
    @assert n == c "Matrix must be square"
    v = [findfirst(Bool.(M[:, k])) for k = 1:n]
    return Permutation(v)
end

export extend
"""
    extend(p::Permutation, new_n::Integer)::Permutation

Given a `Permutation` `p` of `1:n`, create a new `Permutation` of `1:new_n`
that agrees with `p` on elements `1:n` and is the identity on the added extra
elements.

Example
=======
```
julia> p
(1)(2,9,6,7)(3,10,8,5)(4)

julia> extend(p,15)
(1)(2,9,6,7)(3,10,8,5)(4)(11)(12)(13)(14)(15)
```
"""
function extend(p::Permutation, new_n::Integer)::Permutation
    np = length(p)
    @assert new_n >= np "Requested length ($new_n) is smaller than the permutation's length ($np)"
    extras = collect(np+1:new_n)
    new_data = [p.data; extras]
    return Permutation(new_data)
end

using Test
using Permutations
using Random

@testset verbose = true "Permutations.jl" begin

    @testset "Permutation" begin
        p = Permutation(7:-1:1)
        i = Permutation(7)
        @test p * p == i
        @test p == inv(p)
        a = [2, 3, 1, 6, 7, 8, 5, 4, 9]
        p = Permutation(a)
        @test order(p) == 6
        @test p^6 == Permutation(9)
        @test p^-5 == p
        @test p.data == a

        q = Permutation([1, 5, 3, 9, 4, 8, 6, 7, 2])
        @test p * q != q * p
        @test q[2] == 5
        @test q(2) == 5

        P = Matrix(p)
        Q = Matrix(q)
        @test P * Q == Matrix(p * q)
        @test P' == Matrix(inv(p))

        row = [1, 3, 5, 2, 4, 6]
        p = Permutation(row)
        @test length(p) == 6
        @test p[1] == 1
        @test p[Int32(1)] == 1
        @test p[Int64(1)] == 1
        @test p[UInt32(1)] == 1
        @test p[UInt64(1)] == 1
        @test p[BigInt(1)] == 1
        @test length(longest_increasing(p)) == 4
        @test length(longest_decreasing(p)) == 2
        @test length(fixed_points(p)) == 2
        @test sign(p) == -1
        if Sys.WORD_SIZE == 32
            @test_skip hash(p) == hash(p.data)
        else
            @test hash(p) == hash(p.data)
        end

        M = two_row(p)
        @test M[2, :] == row

        @test Permutation(6, 1) == Permutation(6)

        p = RandomPermutation(10)
        @test p * inv(p) == Permutation(10)
        @test p' * p == Permutation(10)
        @test reverse(reverse(p)) == p

        a, b, c, d = Permutation([2, 1, 3, 4]),
        Permutation([1, 2, 4, 3]),
        Permutation([1, 3, 2, 4]),
        Permutation([2, 1, 3, 4])

        @test Matrix(a * b * c * d) == Matrix(a) * Matrix(b) * Matrix(c) * Matrix(d)

        p = RandomPermutation(12)
        d = dict(p)
        for k = 1:12
            @test p(k) == d[k]
            @test p(Int32(k)) == d[k]
            @test p(Int64(k)) == d[k]
            @test p(UInt32(k)) == d[k]
            @test p(UInt64(k)) == d[k]
            @test p(BigInt(k)) == d[k]
        end
        for (k, x) in enumerate(p)
            @test x == d[k]
        end

        p = RandomPermutation(12)
        pp = p * p
        q = sqrt(pp)
        @test q * q == pp

        @test order(Permutation([])) == 1

    end

    @testset "Cycles" begin
        p = Permutation(10)
        @test length(cycles(p)) == 10
        p = Permutation([2, 3, 4, 5, 1])
        @test length(cycles(p)) == 1

        for i = 1:10
            p = RandomPermutation(20)
            cp = cycles(p)
            @test Permutation(cp) == p
        end
    end

    @testset "Transpositions" begin
        p = Transposition(10, 3, 6)
        @test p == inv(p)

        p1 = Permutation(1:10)
        p2 = apply_transposition(p1, 3, 7)
        @test p2.data == [1, 2, 7, 4, 5, 6, 3, 8, 9, 10]
        @test p1 == p2 * p2
        apply_transposition!(p1, 3, 7)
        @test p1 == p2
    end

    @testset "CyclePermutation" begin
        p = CyclePermutation(9)
        @test p^8 == inv(p)
        @test p == Permutation([2, 3, 4, 5, 6, 7, 8, 9, 1])
    end

    @testset "Matrix conversion" begin
        p = RandomPermutation(10)
        M = Matrix(p)
        q = Permutation(M)
        @test p == q
    end

    @testset "CoxeterDecomposition" begin
        n = 10
        p = RandomPermutation(n)
        c = CoxeterDecomposition(p)
        @test p == Permutation(c)


        @test inv(c) * c == CoxeterDecomposition(n, Int[])
        @test inv(c) == c'

        @test CoxeterDecomposition(5, [3, 4, 1]) == CoxeterDecomposition(5, [1, 3, 4])
        @test CoxeterDecomposition(5, [2, 1, 3, 4, 1]) == CoxeterDecomposition(5, [2, 3, 4])
        @test CoxeterDecomposition(5, [1, 3, 4, 3, 4, 3, 4, 1]) ==
              CoxeterDecomposition(5, Int[])

        @test Permutation(CoxeterDecomposition(5, Int[])).data ≈ 1:5
        @test Permutation(CoxeterDecomposition(5, [1])).data == [2; 1; 3:5]
        @test inv(CoxeterDecomposition(6, [1, 3, 5])) == CoxeterDecomposition(6, [1, 3, 5])
        @test CoxeterDecomposition(RandomPermutation(100)) isa CoxeterDecomposition # check for stack overflow
    end


    @testset "PermGen" begin
        X = PermGen(4)
        @test length(X) == factorial(4)

        d = [[2, 3, 4], [1, 3, 4], [1, 2, 4], [1, 2, 3]]
        X = PermGen(d)
        @test sum(length(fixed_points(p)) for p in X) == 0

        X = DerangeGen(5)
        @test length(collect(X)) == 44
    end

    @testset verbose = true "CompiledPermutation" begin

        @test_throws ArgumentError CompiledPermutation([4, 3, 3, 5, 1])

        @testset "Construction & permute! (exhaustive)" begin
            # lots of tests because we use a complex algorithm with @inbounds
            # and don't want to risk segfaults or memory corruption

            N0, N1 = (4, 4) #Set to (5, 20) or more when actively developing CompiledPermutation
            Random.seed!(1729)
            t = @elapsed for n in vcat(0:2000)
                p = fill(0, n)
                v = rand(n)
                all = n <= N0
                for i = 1:(all ? (n + 3)^n : N1)
                    if all
                        digits!(p, i, base = n + 3)
                        p .-= 2
                    elseif i < N1 ÷ 2
                        rand!(p, -1:n+1)
                    else
                        p .= 1:n
                        shuffle!(p)
                    end
                    if (all || i < N1 ÷ 2) &&
                       (sum(p) != sum(1:n) || sort(p) != collect(1:n))
                        @test_throws ArgumentError CompiledPermutation(p)
                    else
                        @test v[p] == permute!(v, CompiledPermutation(p)) === v
                    end
                end
            end
            println("Exhaustive tests took $t seconds.")
        end

        @testset "order" begin
            @test order(CompiledPermutation([2, 3, 1, 6, 7, 8, 5, 4, 9])) == 6
        end
    end

    @testset "inv" begin
        p = RandomPermutation(12)
        @test inv(inv(p)) == p
        v = rand(12)
        @test p * inv(p) == Permutation(12)
        @test inv(p) == p' == invperm(p)
    end

    @testset "invpermute" begin
        v = rand(17)
        p = shuffle(1:17)
        P = Permutation(p)
        cp = CompiledPermutation(p)
        @test v[invperm(p)] ==
              invpermute(v, p) ==
              invpermute(v, P) ==
              invpermute(v, cp) ==
              v[invperm(p)]
        @test_throws DimensionMismatch invpermute(v, Permutation(shuffle(1:18)))
        @test_throws DimensionMismatch invpermute(v, Permutation(shuffle(1:16)))
    end

    @testset "extend" begin
        p = RandomPermutation(12)
        q = extend(p, 15)

        for k = 1:12
            @test p(k) == q(k)
        end
        for k = 13:15
            @test q(k) == k
        end

    end

end

"""
`sort_by_size(list)` returns a sorted copy of `list`
in which the elements are sorted by the `length` function
(from smallest to largest).
"""
function sort_by_size(list::Array)
    sort(list, lt = ((x, y) -> length(x) < length(y)))
end

import Base.sqrt

function weave(c::Array{Int,1})::Array{Int,1}
    nc = length(c)
    if nc % 2 == 0
        error("Attempting to weave $c, an even-length cycle, with itself")
    end
    half = Int((nc + 1) / 2)
    result = zeros(Int, nc)
    j = 1  # index into c
    jj = 1  # index into result
    while j <= nc
        result[j] = c[jj]
        j += 1
        jj = (jj + half) % nc
        if jj == 0
            jj = nc
        end
    end
    return result
end

function weave(c1::Array{Int,1}, c2::Array{Int,1})::Array{Int,1}
    n1 = length(c1)
    n2 = length(c2)
    @assert n1 == n2 "Cycles $c1 and $c2 have different lengths"
    @assert n1 % 2 == 0 "Cycles must have even length to be weaved together"

    result = zeros(Int, 2n1)
    for j = 1:n1
        result[2j-1] = c1[j]
        result[2j] = c2[j]
    end
    return result
end
"""
    sqrt(p::Permutation)

Returns a `Permutation` `q` such that
`q*q==p`. Note: There may be other square roots besides the one
returned. If `p` does not have a square root, an error is thrown.
"""
function sqrt(p::Permutation)::Permutation
    err_msg = "This permutation does not have a square root"
    n = length(p)
    clist = sort_by_size(cycles(p))
    nc = length(clist)
    result = zeros(Int, n)

    idx = 1
    while idx <= nc
        cyc = clist[idx]  # next cycle to process
        m = length(cyc)
        if m % 2 == 1   # an odd cycle
            tmp = weave(cyc)
            for j = 1:m-1
                result[tmp[j]] = tmp[j+1]
            end
            result[tmp[m]] = tmp[1]
            idx += 1
        else
            if idx == nc
                error(err_msg)
            end
            cyc2 = clist[idx+1]
            if length(cyc2) != length(cyc)
                error(err_msg)
            end
            tmp = weave(cyc, cyc2)
            for j = 1:2m-1
                result[tmp[j]] = tmp[j+1]
            end
            result[tmp[2m]] = tmp[1]
            idx += 2
        end
    end
    return Permutation(result)
end

√(p::Permutation) = sqrt(p)

function make_lists(d::Dict{Int,Vector{Int}})
    n = maximum(keys(d))
    allow = [d[k] for k = 1:n]
    return allow
end


"""
    iter_perms

This unexported method is the engine beneth `GenPerms`. The difference is this 
returns a list of vectors, where each vector is a permutation of `1:n` based 
on the table in `allow`.
"""
function iter_perms(allow::Vector{Vector{Int}}, p::Vector{Int} = Int[])
    n = length(allow)
    k = length(p)

    if n == k
        return [p]
    end

    valid_nexts = setdiff(allow[k+1], p)
    nested_its = Iterators.map((x) -> iter_perms(allow, [p; x]), valid_nexts)
    return Iterators.flatten(nested_its)
end

iter_perms(d::Dict{Int,Vector{Int}}) = iter_perms(make_lists(d))





export PermGen


"""
    PermGen

Create an iterator for permutations.
* `PermGen(n::Int)` creates an iterator for all permutations of length `n`.
* `PermGen(d::Dict{Int,Vector{Int}})` creates an iterator for all permutations in which 
   element `k` may be a value in `d[k]`. Alternatively, `d` may be a `Vector` of `Vectors`.

Examples
--------
```
julia> for p in PermGen(3)
       println(p)
       end
(1)(2)(3)
(1)(2,3)
(1,2)(3)
(1,2,3)
(1,3,2)
(1,3)(2)


julia> d = [[2,3,4], [1,3,4], [1,2,4], [1,2,3]];

julia> for p in PermGen(d)
       println(p)
       end
(1,4)(2,3)
(1,3,2,4)
(1,2,3,4)
(1,4,2,3)
(1,3)(2,4)
(1,3,4,2)
(1,2,4,3)
(1,4,3,2)
(1,2)(3,4)
```
"""
function PermGen(allow::Vector{Vector{Int}})
    X = iter_perms(allow)
    return Iterators.map(Permutation, X)
end
PermGen(d::Dict{Int,Vector{Int}}) = PermGen(make_lists(d))

PermGen(n::Int) = Base.Generator(Permutation, permutations(1:n))




function deranged_allow(n::Int)
    d = Dict{Int,Vector{Int}}()
    base = collect(1:n)
    for k = 1:n
        d[k] = setdiff(base, k)
    end
    return d
end

function all_allow(n::Int)
    d = Dict{Int,Vector{Int}}()
    base = collect(1:n)
    for k = 1:n
        d[k] = base
    end
    return d
end

export DerangeGen

"""
    DerangeGen(n::Int)

Create an iterator for all derangements of `{1,2,...,n}`. These are 
all permutations without any fixed points. 
"""
DerangeGen(n::Int) = PermGen(deranged_allow(n))

# Permutations


## Introduction

This package defines a `Permutation`  type for Julia. We only
consider permutations of sets of the form `{1,2,3,...,n}` where `n` is
a positive integer.

A `Permutation` object is created from a one-dimensional array of
integers containing each of the values `1` through `n` exactly once.
```
julia> a = [4,1,3,2,6,5];
julia> p = Permutation(a)
(1,4,2)(3)(5,6)
```
Observe the `Permutation` is printed in disjoint cycle format.

The number of elements in a `Permutation` is determined using the
`length` function:
```
julia> length(p)
6
```

A `Permutation` can be converted to an array (equal to the array used
to construct the `Permutation` in the first place) or can be presented
as a two-row matrix as follows:
```
julia> p.data
6-element Array{Int64,1}:
 4
 1
 3
 2
 6
 5
julia> two_row(p)
2x6 Array{Int64,2}:
 1  2  3  4  5  6
 4  1  3  2  6  5
```

The evaluation of a `Permutation` on a particular element is performed
using square bracket or parenthesis notation:
```
julia> p[2]
1
julia> p(2)
1
```
Of course, bad things happen if an inappropriate element is given:
```
julia> p[7]
ERROR: BoundsError()
 in getindex at ....
```



To get the cycle structure of a `Permutation` (not as a character string,
but as an array of arrays), use `cycles`:
```
julia> cycles(p)
3-element Array{Array{Int64,1},1}:
 [1,4,2]
 [3]
 [5,6]
```

Given a list of disjoint cycles of `1:n`, we can recover the `Permutation`:
```
julia> p = RandomPermutation(12)
(1,6,3,4,11,12,7,2,10,8,9,5)

julia> p = RandomPermutation(12)
(1,12,3,9,4,10,2,7)(5,11,8)(6)

julia> c = cycles(p)
3-element Vector{Vector{Int64}}:
 [1, 12, 3, 9, 4, 10, 2, 7]
 [5, 11, 8]
 [6]

julia> Permutation(c)
(1,12,3,9,4,10,2,7)(5,11,8)(6)
```

## Operations

### Composition 

Composition is denoted by `*`:
```
julia> q = Permutation([1,6,2,3,4,5])
(1)(2,6,5,4,3)
julia> p*q
(1,4,3)(2,5)(6)
julia> q*p
(1,3,2)(4,6)(5)
```
Repeated composition is calculated using `^`, like this: `p^n`.
The exponent may be negative.

### Inverse

The inverse of a `Permutation` is computed using `inv` or as `p'`:
```
julia> q = inv(p)
(1,2,4)(3)(5,6)
julia> p*q
(1)(2)(3)(4)(5)(6)
```

### Square Root


The `sqrt` function returns a compositional square root of the permutation.
That is, if `q=sqrt(p)` then `q*q==p`. Note that not all permutations have
square roots and square roots are not unique.
```
julia> p
(1,12,7,4)(2,8,3)(5,15,11,14)(6,10,13)(9)

julia> q = sqrt(p)
(1,5,12,15,7,11,4,14)(2,3,8)(6,13,10)(9)

julia> q*q == p
true
```

### Matrix Form


The function `Matrix` converts a permutation `p` to a square matrix
whose `i,j`-entry is `1` when `i == p[j]` and `0` otherwise.
```
julia> p = RandomPermutation(6)
(1,5,2,6)(3)(4)

julia> Matrix(p)
6×6 Array{Int64,2}:
 0  0  0  0  0  1
 0  0  0  0  1  0
 0  0  1  0  0  0
 0  0  0  1  0  0
 1  0  0  0  0  0
 0  1  0  0  0  0
```

Note that a permutation matrix `M` can be converted back to a `Permutation`
by calling `Permutation(M)`:
```
julia> p = RandomPermutation(8)
(1,4,5,2,6,8,7)(3)

julia> M = Matrix(p);

julia> q = Permutation(M)
(1,4,5,2,6,8,7)(3)
```

### Sign


The sign of a `Permutation` is `+1` for an even permutation and `-1`
for an odd permutation.
```
julia> p = Permutation([2,3,4,1])
(1,2,3,4)

julia> sign(p)
-1

julia> sign(p*p)
1
```

### Reverse

If one thinks of a permutation as a sequence, then applying `reverse`
to that permutation returns a new permutation based on the reversal of
that sequence. Here's an example:
```
julia> p = RandomPermutation(8)
(1,5,8,4,6)(2,3)(7)

julia> two_row(p)
2x8 Array{Int64,2}:
 1  2  3  4  5  6  7  8
 5  3  2  6  8  1  7  4

julia> two_row(reverse(p))
2x8 Array{Int64,2}:
 1  2  3  4  5  6  7  8
 4  7  1  8  6  2  3  5
```

### Extension

Permutations of different lengths cannot be composed:
```
julia> using Permutations

julia> p = RandomPermutation(8)
(1,4,2)(3,5)(6,8,7)

julia> q = RandomPermutation(10)
(1,2,9,4)(3,8,7,10)(5,6)

julia> p*q
ERROR: Cannot compose Permutations of different lengths
```

However, the `extend` function can be used to create a new `Permutation` 
that has greater length:
```
julia> p
(1,4,2)(3,5)(6,8,7)

julia> extend(p,10)
(1,4,2)(3,5)(6,8,7)(9)(10)
```

The extended `Permutation` is now able to be composed with the longer one:
```
julia> extend(p,10) * q
(1)(2,9)(3,7,10,5,8,6)(4)
```







## Additional Constructors

For convenience, identity and random permutations can be constructed
like this:
```
julia> Permutation(10)
(1)(2)(3)(4)(5)(6)(7)(8)(9)(10)

julia> RandomPermutation(10)
(1,7,6,10,3,2,8,4)(5,9)
```

In addition, we can use `Permutation(n,k)` to create the
`k`'th permutation of the set `{1,2,...,n}`. Of course,
this requires `k` to be between `1` and `n!`.
```
julia> Permutation(6,701)
(1,6,3)(2,5)(4)
```

The function `CyclePermutation` creates a permutation containing a 
single cycle of the form `(1,2,...,n)`.
```
julia> CyclePermutation(5)
(1,2,3,4,5)
```


The function `Transposition` is used to create a permutation containing
a single two-cycle. Use `Transposition(n,a,b)` to create a permutation of 
`1:n` that swaps `a` and `b`.
```
julia> p = Transposition(10,3,5)
(1)(2)(3,5)(4)(6)(7)(8)(9)(10)
```
This function requires `1 ≤ a ≠ b ≤ n`.


## Properties

### Fixed point 

A *fixed point* of a permutation `p` is a value `k` such that
`p[k]==k`. The function `fixed_points` returns a list of the fixed
points of a given permutation.
```
julia> p = RandomPermutation(20)
(1,15,10,9,11,13,12,8,5,7,18,6,2)(3)(4,16,17,19)(14)(20)

julia> fixed_points(p)
3-element Array{Int64,1}:
  3
 14
 20
```
### Longest increasing and decreasing subsequence

The function `longest_increasing` finds a subsequence of a permutation
whose elements are in increasing order. Likewise, `longest_decreasing`
finds a longest decreasing subsequence.
For example:
```
julia> p = RandomPermutation(10)
(1,3,10)(2)(4)(5,6)(7)(8)(9)

julia> two_row(p)
2x10 Array{Int64,2}:
 1  2   3  4  5  6  7  8  9  10
 3  2  10  4  6  5  7  8  9   1

julia> longest_increasing(p)
6-element Array{Int64,1}:
 3
 4
 6
 7
 8
 9

julia> longest_decreasing(p)
4-element Array{Int64,1}:
 10
  6
  5
  1
```

### Test for identity permutation

For a `Permutation`, `p`, the function `isone(p)` returns `true` exactly when 
`p` is an identity `Permutation`.

## Iteration

The function `PermGen` creates a `Permutation` iterator.

With an integer argument, `PermGen(n)` creates an iterator for all permutations of length `n`.
```
julia> for p in PermGen(3)
           println(p)
       end
(1)(2)(3)
(1)(2,3)
(1,2)(3)
(1,2,3)
(1,3,2)
(1,3)(2)
```

Alternatively, `PermGen` may be called with a dictionary of lists or list of lists argument, `d`. 
The permutations generated will have the property that the value of the permutation at argument `k` must be one of the values stored in `d[k]`. 
For example, to find all derangements of `{1,2,3,4}` we do this:
```
julia> d = [ [2,3,4], [1,3,4], [1,2,4], [1,2,3] ]
4-element Vector{Vector{Int64}}:
 [2, 3, 4]
 [1, 3, 4]
 [1, 2, 4]
 [1, 2, 3]
```
Thus `d[1]` gives all allowable values for the first position in the permutation, and so forth. We could equally well have done this:
```
julia> d = Dict{Int, Vector{Int}}();

julia> for k=1:4
           d[k] = setdiff(1:4,k)
       end

julia> d
Dict{Int64, Vector{Int64}} with 4 entries:
  4 => [1, 2, 3]
  2 => [1, 3, 4]
  3 => [1, 2, 4]
  1 => [2, 3, 4]
```

In either case, here we create the nine derangements of `{1,2,3,4}`:
```
julia> [p for p in PermGen(d)]
9-element Vector{Permutation}:
 (1,4)(2,3)
 (1,3,2,4)
 (1,2,3,4)
 (1,4,2,3)
 (1,3)(2,4)
 (1,3,4,2)
 (1,2,4,3)
 (1,4,3,2)
 (1,2)(3,4)
```

The `PermGen` iterator generates permutations one at a time. So this calculation does not use much memory:
```
julia> sum(length(fixed_points(p)) for p in PermGen(10))
3628800
```
> Aside: Notice that the answer is `10!`. It is a fun exerice to show that among all the `n!` permutations of `{1,2,...,n}`, the number of fixed points is `n!`.

We provide `DerangeGen(n)` which generates all derangements of `{1,2,...,n}`, i.e., all permutations without fixed points.
```
julia> for p in DerangeGen(4)
           println(p)
       end
(1,2)(3,4)
(1,2,3,4)
(1,2,4,3)
(1,3,4,2)
(1,3)(2,4)
(1,3,2,4)
(1,4,3,2)
(1,4,2,3)
(1,4)(2,3)
```

Thanks to [Jonah Scheinerman](https://github.com/jscheiny) for the implementation of `PermGen` for restricted permutations. 


## Conversion to a `Dict`

For a permutation `p`, calling `dict(p)` returns a dictionary that behaves
just like `p`.
```
julia> p = RandomPermutation(12)
(1,11,6)(2,8,7)(3)(4,5,9,12,10)

julia> d = dict(p)
Dict{Int64,Int64} with 12 entries:
  2  => 8
  11 => 6
  7  => 2
  9  => 12
  10 => 4
  8  => 7
  6  => 1
  4  => 5
  3  => 3
  5  => 9
  12 => 10
  1  => 11
```


## Coxeter Decomposition

Every permutation can be expressed as a product of transpositions. In
a *Coxeter decomposition* the permutation is the product of transpositions
of the form `(j,j+1)`.
Given a permutation `p`, we get this form
with `CoxeterDecomposition(p)`:
```
julia> p = Permutation([2,4,3,5,1,6,8,7])
(1,2,4,5)(3)(6)(7,8)

julia> pp = CoxeterDecomposition(p)
Permutation of 1:8: (1,2)(2,3)(3,4)(2,3)(4,5)(7,8)
```
The original permutation can be recovered like this:
```
julia> Permutation(pp)
(1,2,4,5)(3)(6)(7,8)
```
